/** 
 * TPIP Basic Library 
 * @file chg_bkColor.cpp
 * @brief TPIP Basic ֐Ft@C݂邩`FbN֐
 *
 * @author Katayama
 * @date 2009-01-26
 * @version 1.00 : 2009/01/26 katayama
 *
 * Copyright (C) 2009 TPIP User Community All rights reserved.
 * ̃t@C̒쌠́ATPIP[U[R~jeB̋Kɏ]
 * gp܂B
 */
#include <windows.h>

/** obNEJ[ؑ ֐iRS-UDPj^ʗpj
 *  COLORREF chg_BkColor( HDC hDC, unsigned char id)
 * @param  hDC  : handle to device context
 * @param  id   : obNJ[ؑ֐l
 * @retval == 0 : G[
 * @retval != 0 : J[nh[
 */
COLORREF chg_BkColor( HDC hDC, unsigned char id)
{
	DWORD bk_c ;

	bk_c = RGB( 0,  0,  0);
	if ( id > 10/2  ) bk_c = RGB(  0,   0, 150);	// 10ms
	if ( id > 100/2 ) bk_c = RGB(100, 100,   0);	// 100ms
	if ( id > 200/2 ) bk_c = RGB(150,   0,   0);	// 500ms
	if ( id == 254  ) bk_c = RGB(  0, 150,   0);	// SIO -> UDP
	return (SetBkColor(hDC, bk_c));
}
