/** 
 * TPIP Basic Library 
 * @file font_set.cpp
 * @brief TPIP Basic ֐F\EBh̃tHgZbg֐
 *
 * @author Katayama
 * @date 2009-01-26
 * @version 1.00 : 2009/01/26 katayama
 *
 * Copyright (C) 2009 TPIP User Community All rights reserved.
 * ̃t@C̒쌠́ATPIP[U[R~jeB̋Kɏ]
 * gp܂B
 */
#include <windows.h>

static HFONT  hFont_T0;
static HFONT  hFont_T1;
static HFONT  hFont_T2;

/** \gp̃tHg
 *  void Font_init(void)
 */
void Font_init(void)
{
	hFont_T0 = CreateFont( 17, 0, 0, 0,
				   	0,FALSE, FALSE, FALSE,
					SHIFTJIS_CHARSET,
					OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
					DEFAULT_QUALITY,
					FIXED_PITCH | FF_DONTCARE,
					"lr oSVbN" );

	hFont_T1 = CreateFont( 15, 0, 0, 0,
				   	FW_HEAVY,FALSE, FALSE, FALSE,
					ANSI_CHARSET,
					OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
					DEFAULT_QUALITY,
					FIXED_PITCH | FF_DONTCARE,
					"Arial" );

	hFont_T2 = CreateFont( 13, 0, 0, 0,
				   	0,FALSE, FALSE, FALSE,
					SHIFTJIS_CHARSET,
					OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,
					DEFAULT_QUALITY,
					FIXED_PITCH | FF_DONTCARE,
					"lr oSVbN" );


}

/** \gp̃tHg폜
 *  void Font_del(void)
 */
void Font_del(void)
{
	DeleteObject( hFont_T0 );
	DeleteObject( hFont_T1 );
	DeleteObject( hFont_T2 );
}

/** \gp̃tHgEnh[o
 *  HFONT Font_set( int Font_ID )
 * @param  Font_ID : tHgIDiO`Qj
 * @retval NULL  : G[
 * @retval !NULL : tHgEnh[
 */
HFONT Font_set( int Font_ID )
{
	HFONT ans;

	switch(Font_ID)
	{
	case 0:
		ans = hFont_T0;
		break;
	case 1:
		ans = hFont_T1;
		break;
	case 2:
		ans = hFont_T2;
		break;
	default:
		ans = 0;
		break;
	}
	return (ans);
}

