/** 
 * @file  RS_com.h
 * @brief RS232ʐM Header file
 *
 * @author Katayama
 * @date 2009-01-26
 * @version 1.00 : 2009/01/26 katayama
 *
 * Copyright (C) 2009 TPIP User Community All rights reserved.
 * ̃t@C̒쌠́ATPIP[U[R~jeB̋Kɏ]
 * gp܂B
 */

#ifndef __UDP_COM_H__
#define __UDP_COM_H__
#include "COM_trace.h"

typedef unsigned char   u_char;
typedef unsigned short  u_short;
typedef unsigned int    u_int;
typedef unsigned long   u_long;

extern int  UDP_com_init   (void);
extern int  UDP_com_init_ex(char* host_adr, int port_no, char* com_port, int sio_speed);
extern int  UDP_com_end    (void);
extern void UDP_com_lock   (void);
extern void UDP_com_unlock (void);
extern int  UDP_set_sddata( void* sd_buf, int sd_sz );
extern int  UDP_get_rvdata( void* rv_buf );
extern char* UDP_get_info(void);

extern COM_trace* tr;

#endif /* ifndef __UDP_COM_H__ */
