/** 
 * @file  com_sub.cpp
 * @brief ʐM֘A@Tu[`iRRCpj module
 *
 * @author Katayama
 * @date 2009-01-26
 * @version 1.00 : 2009/01/26 katayama
 * @version 2.00 : 2009/04/01 katayama (for TPIP2)
 * @version 2.01 : 2009/06/09 katayama (for TPIP2)
 * @version 3.01 : 2014/03/25 tanimoto (for TPIP3)
 *
 * Copyright (C) 2009 TPIP User Community All rights reserved.
 * ̃t@C̒쌠́ATPIP[U[R~jeB̋Kɏ]
 * gp܂B
 */
#include <windows.h>
#include <stdio.h>
#include "sub_module.h"
#include "com_sub.h"

#include "def_dev.h"
#pragma warning(disable:4996)	// ZLeBアÂ֐ɑ΂x̉


static struct OUT_DT_STR out_dt[4];


static struct INP_DT_STR inp_dt[4];	// ZT[̓f[^


/** ʐM[h@\֐
 * @fn     void Dsp_Com_stat(HDC hDC, int x, int y, int req, int stat)
 * @param  hDC  : device context handle
 * @param  x    : \ʒu(x)
 * @param  y    : \ʒu(y)
 * @param  req  : ʐMv[h
 * @param  stat : ʐM[h
 *
 */
void Dsp_Com_stat(HDC hDC, int x, int y, int req, int stat)
{
	COLORREF old_color;

	old_color = SetTextColor(hDC, RGB(  80, 80, 80));
	if (req & 0x01) {
		if (stat & 0x01) SetTextColor(hDC, RGB(  0, 255, 0));
		else SetTextColor(hDC, RGB(  255, 0, 0));
	}
	TextOut(hDC, x, y, " JPEG",lstrlen(" JPEG"));

	SetTextColor(hDC, RGB(  80, 80, 80));
	if (req & 0x02) {
		if (stat & 0x02) SetTextColor(hDC, RGB(  0, 255, 0));
		else SetTextColor(hDC, RGB(  255, 0, 0));
	}
	TextOut(hDC, x, y+20, "  SIO",lstrlen("  SIO"));

	if (req & 0x04) {
		if (stat & 0x04) {
			SetTextColor(hDC, RGB(  0, 255, 255));
			TextOut(hDC, x, y+20, " user",lstrlen(" user"));
		}
	}

	SetTextColor(hDC, old_color);
}

/** k`mdgx@\֐
 * @fn     void Dsp_Wlan_lev(HDC hDC, int x0, int y0, int lev)
 * @param  hDC  : device context handle
 * @param  x0   : \ʒu(x)
 * @param  y0   : \ʒu(y)
 * @param  lev  : k`mdgxx
 *
 */
void Dsp_Wlan_lev(HDC hDC, int x0, int y0, int lev)
{
	HPEN   hPen0 ;
	HPEN   hPen ;
	HPEN   hPen_b ;
	int i;
	int x,y;

	x = x0+10; y = y0+19;
	hPen0  = CreatePen(PS_SOLID, 1, RGB( 255, 255, 255));
	hPen   = CreatePen(PS_SOLID, 2, RGB( 255, 255, 255));
	hPen_b = CreatePen(PS_SOLID, 2, RGB(   0,   0,   0));
	SelectObject(hDC, hPen0 );
	MoveToEx ( hDC , x0, y0, NULL);
	LineTo   ( hDC , x0+10, y0);
	LineTo   ( hDC , x0+5, y0+5);
	LineTo   ( hDC , x0, y0);
	MoveToEx ( hDC , x0+5, y0+5, NULL);
	LineTo   ( hDC , x0+5, y0+20);
	SelectObject(hDC, hPen );
	for ( i = 0 ; i < 5 ; i++ )
	{
		if ( i == lev) 	SelectObject(hDC, hPen_b );
		MoveToEx ( hDC , x+i*5, y, NULL);
		LineTo   ( hDC , x+i*5, y-(i)*4-4);
	}
	DeleteObject (hPen);
	DeleteObject (hPen_b);
	DeleteObject (hPen0);
}

/** ʐMԁ@\֐
 * @fn     void Dsp_Com_Mode(HDC hDC)
 * @param  hDC  : device context handle
 *
 */
void Dsp_Com_Mode(HDC hDC)
{
	char	Msg[256] ;
	int		x,y;
	int		req_spd,now_spd;
	int		w_lnk;
	int		com_mode;
	static char MC_Name[32] = "192.168.0.200";

	strcpy(MC_Name,ip_address);
	com_mode = TPJT_get_com_mode();
	//com_mode = TPJT_get_com_req();
	x = 0; y = 0;
	switch(com_mode)
	{
		case 0:			//@ACh
			wsprintf(Msg,"<   Offline   >                      ");        // "ؒf"
			break;
		case 1:			//@ڑX^[g҂
			wsprintf(Msg,"<    Ready    >  [ %s ]              ",MC_Name); // ""
			break;
		case 2:			//@ڑX^[g
			wsprintf(Msg,"<Connecting...>  [ %s ]              ",MC_Name); // "ڑ"
			break;
		case 3:			//@ڑ҂
			wsprintf(Msg,"<Connecting...>  [ %s ]              ",MC_Name); // "ڑ"
			break;
		case 4:			//@ڑ
			wsprintf(Msg,"<   Online    >  [ %s ]              ",MC_Name); // "ڑ"
			break;
		case -1:			//@ُiG[j
			wsprintf(Msg,"<    Error    >  [ %s ]              ",MC_Name); // "ُ"
			break;
		default:
			wsprintf(Msg,"<    ?????    >");
			break;
	}
	w_lnk = Limit(TPJT_Get_Wlink(),0,50)/10;

	TextOut(hDC, x+50, y+5, Msg, lstrlen(Msg));
	Dsp_Com_stat(hDC, x, y+5, TPJT_get_com_req(), TPJT_get_com_stat());

	req_spd = (get_JPEG_speed())/100;
	now_spd = (TPJT_get_vspeed())/100;
	wsprintf(Msg,"ReqSpeed:%2d.%01d[Mbps] Speed:%2d.%01d[Mbps]"
		,req_spd/10,req_spd%10,now_spd/10,now_spd%10);
	TextOut(hDC, x+50, y+25, Msg, lstrlen(Msg));
	Dsp_Wlan_lev(hDC, x+500, y+25, w_lnk);
}

/** JNO.@\֐
 * @fn     void Dsp_camera_no(HDC hdc, int x, int y)
 * @param  hdc : device context handle
 * @param  x   : \ʒu(x)
 * @param  y   : \ʒu(y)
 *
 */
void Dsp_camera_no(HDC hdc, int x, int y)
{
	char	Msg[256] ;

	wsprintf(Msg,"Camera NO: %d",camera_no+1);
	TextOut(hdc, x, y, Msg, lstrlen(Msg));

}

/**  / ZT[@XV֐
 * @fn     void ref_ctrl_dt(void)
 *
 */
void ref_ctrl_dt( void )
{
	int i ;


	TPJT_get_sens(&inp_dt, sizeof(inp_dt));	// ZT[̓f[^捞

	Batt_i = inp_dt[0].batt ;		// [Ver 2.00] 
	Batt_v = (300 * Batt_i)/ 3000 ;
	for (i = 0; i < 8 ; i++)
	{
		AI_ch[i] = (inp_dt[0].AI[i] * 500)/ 65535; // 0 - 5.00 V		// [Ver 2.00] 
	}

	PI_ch[0] = abs(inp_dt[0].PI[0] / 100) ; // rpm => 1/100		// [Ver 2.00] 
	PI_ch[1] = abs(inp_dt[0].PI[1] / 100) ; // rpm => 1/100		// [Ver 2.00] 
	PI_ch[2] = abs(inp_dt[0].PI[2] / 100) ; // rpm => 1/100		// [Ver 2.00] 
	PI_ch[3] = abs(inp_dt[0].PI[3] / 100) ; // rpm => 1/100		// [Ver 2.00] 

	// TPIP3 DC[^o͂͂܂
	//out_dt[0]. = rang_chg(MT, 0, 255, -1000, 1000);		// [Ver 2.00] 

	out_dt[0].d_out = d_out & 0x01ff;

	for ( i = 0 ; i < 4 ; i++) {
		out_dt[0].PWM[i] = rang_chg(PWM[i], 0,255,-1000,1000);	// 0.8ms(wide)		// [Ver 2.00] 
	}
	for ( i = 0 ; i < 16 ; i++) {
		out_dt[0].PWM2[i] = rang_chg(PWM2[i], 0,255,-1000,1000);	// 0.8ms(wide)		// [Ver 2.00] 
	}
	TPJT_set_ctrl(&out_dt, sizeof(out_dt));	// o̓f[^Zbg

	return;
}

/** J@ؑ֊֐
 * @fn     void Camera_Chg(int on_flg)
 * @param  on_flg : comera no.
 *
 */
void Camera_Chg(int on_flg)
{

	if (on_flg > 3) return ;
	TPJT_chg_camera(on_flg);
}

/**  Set JPEG speed
 *   int set_JPEG_speed( int n)
 *   @param  n  : ]vx@n [Kbps]
 *   @retval    : ݒl
 */
int set_JPEG_speed( int n)
{
	n = Limit( n , 0 , 10000);
	JPEG_speed[vga] = n;
	return (JPEG_speed[vga]);
}

/**  Get JPEG speed
 *   int get_JPEG_speed(void)
 *   @retval   :  ]v ݒl
 */
int get_JPEG_speed(void)
{
	return (JPEG_speed[vga]);
}
