/** 
 * TPIP Basic Library 
 * @file rang_chg_dz.cpp
 * @brief TPIP Basic ֐Fo͒l@Wϊ֐msяtn
 *
 * @author Katayama
 * @date 2009-01-26
 * @version 1.00 : 2009/01/26 katayama
 *
 * Copyright (C) 2009 TPIP User Community All rights reserved.
 * ̃t@C̒쌠́ATPIP[U[R~jeB̋Kɏ]
 * gp܂B
 */
#include <stdlib.h>
extern int Limit(int num,int min,int max);

/** o͒l@Wϊ ֐msяtn
 *  int rang_chg_dzone(int x,int x_min,int x_max,int y_min,int y_max,int dzone)
 * @param  x     : ͒l
 * @param  x_min : ͒lf[^͈́ilj
 * @param  x_max : ͒lf[^͈́ilj
 * @param  y_min : o͒lf[^͈́ilj
 * @param  y_max : o͒lf[^͈́ilj
 * @param  dzone : sюwiO`POOj
 * @retval (int) : o͒liWϊlj
 */
int rang_chg_dzone(int x,int x_min,int x_max,int y_min,int y_max,int dzone)
{
	int x_span,y_span;
	int x_mid,y_mid;
	int x_bias,y_bias;
	float _dzone;
	float _xr,_xd,_y;
	int   x0,x_sign,y;

	x = Limit( x, x_min, x_max);
	x_span = x_max - x_min;
	y_span = y_max - y_min;
	x_mid  = x_span / 2;
	y_mid  = y_span / 2;
	x_bias = x_mid + x_min;
	y_bias = y_mid + y_min;
	_dzone = (float)(dzone/100.0);

	x0     = x - x_bias;
	x_sign = ((x0 >= 0) ? 1 : -1);
	_xr    = ((float)abs(x0)/(float)x_mid);
	_xd    = (float)(( _xr < _dzone ) ? 0.0 : (((_xr - _dzone)/(1.0 - _dzone))*(float)x_sign));
	_y     = (float)(y_mid * _xd + y_bias);
	y      = (int)((_y >=0) ? (_y+0.5) : (_y-0.5));
	return (y);
}
